#!/bin/sh
. /dtv/SGO.env
chmod 755 /dtv/cgi-bin/* #just for my needs. too lazy to edit user rights over shell.
################
SELF=Infopage.cgi
AWK="busybox awk"
CUT="busybox cut"
SED="busybox sed"
GREP="busybox grep"

BUILD="2012-05-04"


#################

run_time=`cat /proc/uptime | $AWK '{print $1}'`
TZ=UTC 
UPTIME="<div class="postmenu">TV\`s up time: `$AWK -v t=$run_time 'BEGIN{print strftime("%Hh %Mmin",t)}'`</div>"

cnt="<center>"
cnt_end="</center>"
syst="<img src=../samygo.png alt=WebGUI SamyGO! /><br><br>$UPTIME "

if [ "$QUERY_STRING" == "" ]
        then
        QUERY_STRING="vip"
fi 

SYSMN1="<u><a href=$SELF?sys>CPU & Memory</a></u>"
SYSMN2="<u><a href=$SELF?sys_filesys>Filesystem</a></u>"
SYSMN3="<u><a href=$SELF?sys_process>Processes</a></u>"
SYSMN4="<u><a href=$SELF?sys_modules>Loaded modules</a></u>"
SYSMN5="<u><a href=$SELF?sys_usb>USB Devices</a></u>"
SYSMN6="<u><a href=$SELF?sys_dmesg>dmesg</a></u>"

NETMN1="<u><a href=$SELF?net>Network</a></u>"
NETMN2="<u><a href=$SELF?net_ext>Extended network info</a></u>"
NETMN3="<u><a href=$SELF?net_bt>Bluetooth devices </a></u>"

SHARESMN1="<u><a href=$SELF?shares>Network shares</a></u>"
SHARESMN2="<u><a href=$SELF?shares_ext_nfs>Extended info</a></u>"
SHARESMN3="<u><a href=$SELF?shares_ext_smb>Extended info</a></u>"


LOGMN1="<u><a href=$SELF?log>Logs</a></u>"
LOGMN2="<u><a href=$SELF?log_aplog>Apache log</a></u>"
LOGMN3="<u><a href=$SELF?log_clist>Cookies</a></u>"

case "$QUERY_STRING" in

sys) vhead="${syst}"
        cnt=""
        cnt_end=""
        tab="`cat /proc/version`<br><br>"
		tab="${tab}<div class="postmenu"><b>CPU & Memory</b>  |  $SYSMN2  |  $SYSMN3  |  $SYSMN4  |  $SYSMN5  |  $SYSMN6</div><br>"
        tab="${tab}<table><td valign=top><u>CPU</u><div class="posttext"><pre>`cat /proc/cpuinfo`</pre></div></td>"
        tab="${tab}<td><u>Memory </u><div class="posttext"><pre>`cat /proc/meminfo`</pre></td></table></pre></div>"
		;;
sys_filesys) vhead="${syst}"
        cnt=""
        cnt_end=""
        tab="`cat /proc/version`<br><br>"
		tab="${tab}<div class="postmenu">$SYSMN1 | <b>Filesystem</b>  |  $SYSMN3  |  $SYSMN4  |  $SYSMN5  |  $SYSMN6</div><br><br>"
        tab="${tab}<div class="posttext"><pre>`/bin/df -h`</pre></div>"	
		;;
sys_process) vhead="${syst}"
        cnt=""
        cnt_end=""
        tab="`cat /proc/version`<br><br>"
		tab="${tab}<div class="postmenu">$SYSMN1  |  $SYSMN2  |  <b>Processes</b>  |  $SYSMN4  |  $SYSMN5  |  $SYSMN6</div><br><br>"
        tab="${tab}<div class="posttext"><pre>`ps axf`$</pre></div>"
		;;
sys_modules) vhead="${syst}"
        cnt=""
        cnt_end=""
        tab="`cat /proc/version`<br><br>"
		tab="${tab}<div class="postmenu">$SYSMN1  |  $SYSMN2  |  $SYSMN3  |  <b>Loaded modules</b>  |  $SYSMN5  |  $SYSMN6</div><br><br>"
        tab="${tab}<div class="posttext"><pre>`lsmod`</pre></div>"
		;;
sys_usb) vhead="${syst}"
        cnt=""
        cnt_end=""
        tab="`cat /proc/version`<br><br>"
		tab="${tab}<div class="postmenu">$SYSMN1  |  $SYSMN2  |  $SYSMN3  |  $SYSMN4  |  <b>USB Devices</b>  |  $SYSMN6</div><br><br>"
		tab="${tab}<div class="posttext"><pre>`cat /dtv/usb/usblog | $GREP "sd*"`</pre></div>"
#	tab="${tab}<div class="posttext"><pre>`cat /dtv/usb/usblog | $GREP "sd*" | awk '{ if ((NR % 5) == 0) printf("\n"); print; }'`</pre></div>"
#	tab="${tab}<div class="posttext"><pre>`cat /dtv/usb/usblog | $GREP "sd*" | awk '$0!~/^$/ {print $0}'`</pre></div>"
		;;
sys_dmesg) vhead="${syst}"
        cnt=""
        cnt_end=""
        tab="`cat /proc/version`<br><br>"
		tab="${tab}<div class="postmenu">$SYSMN1 |  $SYSMN2  |  $SYSMN3  |  $SYSMN4  |  $SYSMN5  |  <b>dmesg</b></div><br><br>"
		tab="${tab}<div class="posttext"><pre>`dmesg`</pre></div>"
		;;
net)    vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="${tab}<div class="postmenu"><b>Network</b>  |  $NETMN2  |  $NETMN3</u></div>"
        tab="${tab}<br><u>Currently used MAC:</u><br><br><div class="posttext"><pre>`cat /mtd_rwcommon/common/WidgetMgr/network.info`</pre></div>"
        tab="${tab}<br><u>DUID: </u><br><br><div class="posttext"><pre>`cat /mtd_rwarea/otn/otn.cfg | $GREP "LOG_URL=" | $SED 's_.*/__'`</pre></div>"
        tab="${tab}<br><u>Widget Server:</u><br><br><div class="posttext"><pre>`cat /mtd_rwcommon/common/WidgetMgr/userServerIPAddress.dat`</pre></div>"
	NT=$( cat /mtd_rwarea/network_type_info | $AWK '{print NR}')
        tab="${tab}<br><u>Network type:</u><br><br><div class="posttext"><pre>`if [ $NT -eq "1" ]; then echo "Wired"; else echo "Wireless";fi`</pre></div>"
	if [ $NT -eq "1" ];then
        tab="${tab}<br><u>Network Settings:</u><br><br><div class="posttext"><pre>`cat /mtd_rwarea/network_Wired*`</pre></div>"
	fi
	if [ $NT -eq "0" ];then
        tab="${tab}<br><u>Network Settings:</u><br><br><div class="posttext"><pre>`cat /mtd_rwarea/network_Wifi*`</pre></div>"
	fi
        tab="${tab}<br><u>DNS</u><br><br><div class="posttext"><pre>`cat /mtd_rwarea/resolv.conf | $AWK 'NR==1{print $2}'`</pre></div>"
        tab="${tab}<br><u>External IP</u><br><br><div class="posttext"><pre>`cat /mtd_rwarea/otn/configuration.txt | $GREP -o -e 'real_ip=\"[0-9]*\.[0-9]*\.[0-9]*\.[0-9]*\"' | $SED 's/"//g;s/real_ip\=//g'`</pre></div>"
		;;
		
net_bt)		vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="${tab}<div class="postmenu">$NETMN1  |  $NETMN2  |  <b>Bluetooth devices</b></div><br><br>"
		tab="${tab}<u>Bluetooth Info:</u><pre>`cd /mtd_rwarea/ && for filename in Bluetooth*; do echo "<br><u>$filename</u><br>"; cat "$filename";done`</pre>"
		;;
		
net_ext)	vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="${tab}<div class="postmenu">$NETMN1  |  <b>Extended network info</b>  |  $NETMN3</div>"
        tab="${tab}<br><u>Route</u><br><br><div class="posttext"><pre>`route -en`</pre></div>"
        tab="${tab}<br><u>Arp</u><br><br><div class="posttext"><pre>`cat /proc/net/arp`</pre></div>"
        tab="${tab}<br><u>Hosts</u><br><br><div class="posttext"><pre>`cat /etc/hosts | $AWK '!/\#/,/)/{print}'`</pre></div>"
        tab="${tab}<br><u>Interfaces</u><br><br><div class="posttext"><pre>`ifconfig`</pre></div>"
		;;
		
shares) vhead="${syst}"
        cnt=""
        cnt_end=""
		if [ `/bin/mount | $GREP -c "nfs"` -gt 0 ]; then
		tab="${tab}<div class="postmenu"><b>Network shares found:</b></div><br>"
		tab="${tab}<b>NFS</b> ($SHARESMN2) <div class="posttext"><pre>`/bin/mount | $GREP "nfs" | $AWK '{print $1,_ $2,_ $3}'`</pre></div><br>"
#			tab="${tab}$SHARESMN2"
		fi
	
		if [ `/bin/mount | $GREP -c "cifs"` -gt 0 ]; then
			tab="${tab}<div class="postmenu"><b>Network shares found:</b></div><br>"
			tab="${tab}<b>Samba</b> ($SHARESMN3)<div class="posttext"><pre>`/bin/mount | $GREP "cifs" | $AWK '{print $1,_ $2,_ $3}'`</pre></div>" 
		fi
		;;
shares_ext_nfs)vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="${tab}<div class="postmenu"><b>Network shares found:</b></div><br>"
		tab="${tab}<u><a href=$SELF?shares>NFS</a></u> | <b>Extended info</b><div class="posttext"><pre>`/bin/mount | $GREP "nfs"`</pre></div><br>"
		;;
shares_ext_smb)vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="${tab}<div class="postmenu"><b>Network shares found:</b></div><br>"
		tab="${tab}<u><a href=$SELF?shares>Samba</a></u> | <b>Extended info</b><div class="posttext"><pre>`/bin/mount | $GREP "nfs"`</pre></div><br>"
		;;
shares_nfs_edit)vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="${tab}<div class="postmenu"><b>Edit</b></div><br>"
	;;
#log)    vhead="${syst}"
#        cnt=""
#        cnt_end=""
#        tab="${tab}<u>System Logfile</u><br><pre>`tail -n 5000 /tmp/syslog.log`</pre>"
#		tab="${tab}<u><a href=$SELF?clog>Clear Log</a><br></u></center>";;
#	
#clog)	vhead="${syst}"
#        cnt=""
#        cnt_end=""
#		tab="${tab}<center><u>Log Empty</u></center><br><div class="posttext"><pre>`echo "" > /tmp/syslog.log`</pre></div>";;
#

firmw)   vhead="${syst}"
        cnt=""
        cnt_end=""
        tab="${tab}<u>Installed Firmware:</u><br><br><div class="posttext"><pre>`if [ -f /mtd_exe/.info ];then cat /mtd_exe/.info;elif [ -f /dtv/.info ];then cat /dtv/.info;fi` `cat /.version | $AWK '{print $2}' | $SED 's/"//g'`</pre></div>"
		tab="${tab}<br><u>Platform:</u><br><br><div class="posttext"><pre>`cat /.version | $AWK '{print $1}' | $SED 's/"//g'`</pre></div>"
        tab="${tab}<br><u>1st Image version:</u><br><br><div class="posttext"><pre>`[ -f /mtd_rwarea/RVersion.0 ] && cat /mtd_rwarea/RVersion.0 || cat /mtd_rwarea/Version.0 || echo "does not exist!"`</pre></div>"
        tab="${tab}<br><u>2nd Image version:</u><br><br><div class="posttext"><pre>`[ -f /mtd_rwarea/RVersion.1 ] && cat /mtd_rwarea/RVersion.1 || cat /mtd_rwarea/Version.1 || echo "does not exist!"`</pre></div>"
		;;
softw)   vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="${tab}<u>Installed widgets</u><br><div class="posttext"><pre>`cat /mtd_rwcommon/common/WidgetMgr/info.xml | $GREP "name" | $SED 's/name\=//g' | $SED 's/"//g'`</pre></div>"
		;;
		
vip) vhead="${syst}"
        cnt=""
        cnt_end=""
        tab="${tab}<div class="postmenu"><b>Stuff you should Know</b></div><br>"
		tab="${tab}<center><table width=100% border=0>"
		tab="${tab}<td width=35%>"
		tab="${tab}<u>CPU:</u><pre>`head -1 /proc/cpuinfo | $AWK -F ': ' '{ print $2 }'`</pre>"
 		tab="${tab}<u>Platform:</u><pre>`cat /.version | $AWK '{print $1}' | $SED 's/"//g'`</pre>"
        tab="${tab}<u>Installed Firmware:</u><pre>`if [ -f /mtd_exe/.info ];then cat /mtd_exe/.info;elif [ -f /dtv/.info ];then cat /dtv/.info;fi` `cat /.version | $AWK '{print $2}' | $SED 's/"//g'`</pre>"
		tab="${tab}<u>DUID: </u><pre>`cat /mtd_rwarea/otn/otn.cfg | $GREP "LOG_URL=" | $SED 's_.*/__'`</pre></td>"
		tab="${tab}<td><u>Local IP</u><pre>`cat /mtd_rwarea/otn/configuration.txt | $GREP -o -e 'given_ip=\"[0-9]*\.[0-9]*\.[0-9]*\.[0-9]*\"' | $SED 's/"//g;s/given_ip\=//g'`</pre>"
		tab="${tab}<u>External IP</u><pre>`cat /mtd_rwarea/otn/configuration.txt | $GREP -o -e 'real_ip=\"[0-9]*\.[0-9]*\.[0-9]*\.[0-9]*\"' | $SED 's/"//g;s/real_ip\=//g'`</pre>"
		tab="${tab}<u>DNS</u><pre>`cat /mtd_rwarea/resolv.conf | $AWK '{print $2}' | $GREP '[0-9].[0-9].[0-9].[0-9]'`</pre>"
		tab="${tab}</td></table></center>"
		tab="${tab}<div class="post">Format is wrong. To be corrected in future...<pre>SAMYGO VERSION DATE: `cat $SYSROOT/etc/version | $AWK ' BEGIN {OFS="/"} {print substr($1,5,2), substr($1,7,2), substr($1,1,4)}'`<br>"
		tab="${tab}SAMYGO RELEASE DATE: `cat $SYSROOT/etc/release | $SED 's/[0-9]\{4\}/& /g'`<br>"
#		tab="${tab}SAMYGO RELEASE DATE: `cat $SYSROOT/etc/version | $AWK '{ print strftime("%c", $0); }'`<br>"
#		tab="${tab}SAMYGO RELEASE DATE: `cat $SYSROOT/etc/release | $SED 's/[0-9]\{4\}/& /g'`<br>"
		tab="${tab}SAMYGO RELEASE DATE: `cat $SYSROOT/etc/timestamp | $AWK ' BEGIN {OFS="/"} {print substr($1,5,2), substr($1,7,2), substr($1,1,4)}'`</pre></div>"
		;;
log) vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="${tab}$LOGMN2  |  $LOGMN3 "
		;;
		
log_clist) vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="${tab}$LOGMN2  |  <b>Cookies</b><br><br><div class="posttext"><pre>`cat /mtd_rwarea/cookie.info`</pre></div><u><a href=$SELF?log_delcook>Delete cookies</a></u><br><br>"
		;;
		
log_delcook) vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="${tab}$LOGMN2  |  <b>Delete cookies</b><div class="posttext"><pre>`echo "empty" > /mtd_rwarea/cookie.info && echo "Done!" || echo "Failed"`</pre></div>"
		;;
log_aplog) vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="<b>Apache log</b>  |  $LOGMN3 <br><br><div class="posttext"><pre>`cat /dtv/apache_error_log`</pre></div><u><a href=$SELF?log_dellog>Delete log</a></u>"
		;;
log_dellog) vhead="${syst}"
        cnt=""
        cnt_end=""
		tab="${tab}<b>Delete apache log</b>  |  $LOGMN3  <div class="posttext"><pre>`echo "empty" > /dtv/apache_error_log && echo "Done!" || echo "Failed"`</pre></div>"
		;;
#template) vhead="${syst}"
#        cnt=""
#        cnt_end=""
#		tab="${tab}<center><u>Text</u></center><br><pre>`cmd`</pre>"
#		;;
esac

echo "Content-type: text/html; charset=utf-8"
echo
echo "<HTML><HEAD><TITLE>System Info</TITLE><meta http-equiv=pragma content=no-cache>"
echo "<meta http-equiv=cache-control content=no-cache, no-store, must-revalidate>"
echo "<link rel="stylesheet" type="text/css" href="../style.css" /> "
echo "</HEAD><BODY>"
echo "<table cols=1 width=100% border=0>"
echo "<tr><td><center><h3>${vhead}</h3></center></td>"
echo "</center></td></tr></table>"
echo "<center><script language=JavaScript>"
echo "document.writeln(document.lastModified)"
echo "</script></center><br>"
echo "<table width=100% border=0><tr><td valign=top>"
echo "<fieldset><legent>Menu:</legent><br><a href=$SELF?vip>Important</a>"
echo "<a href=$SELF?sys>General</a><br>"
echo "<a href=$SELF?firmw>Firmware</a><br>"
echo "<a href=$SELF?softw>Software</a><br>"
echo "<a href=$SELF?shares>Shares</a><br>"
echo "<a href=$SELF?net>Network</a><br>"
echo "<a href=$SELF?log_aplog>Logs</a>"
#echo "<a href=$SELF?log>Syslog</a>"

echo "</fieldset>"
echo "<td width=100%>${cnt} ${tab} ${cnt_end}</td></table>"
echo "<hr>"
run_time2=`cat /proc/uptime | $AWK '{print $1}'`
run_time=`echo "$run_time2 $run_time" | $AWK '{printf "%s\n",$1-$2}'`
echo "<center>Generated in ${run_time} sec.</center>"
echo "<center>BUILD=$BUILD</center>"
echo "</BODY></HTML>"
